import ReactDOM from 'react-dom/client'
import { Provider } from 'react-redux'
import { HashRouter } from 'react-router-dom'

import setRootPixel from '@arco-design/mobile-react/tools/flexible'
import dayjs from 'dayjs'
import { PersistGate } from 'redux-persist/integration/react'

import { store, persistor } from '@/store'

import Routes from './router'
import AuthRouter from './router/AuthRouter'

import 'dayjs/locale/zh-cn'
dayjs.locale('zh-cn')

const ROOT = document.getElementById('root')

setRootPixel()

const App = () => (
  // <React.StrictMode>
  <Provider store={store}>
    <PersistGate loading={null} persistor={persistor}>
      <HashRouter>
        <AuthRouter>
          <Routes />
        </AuthRouter>
      </HashRouter>
    </PersistGate>
  </Provider>
  // </React.StrictMode>
)
ROOT && ReactDOM.createRoot(ROOT).render(<App />)
