import React, { useEffect, useRef, useState } from 'react'

// import { Button, Cell, Toast } from '@arco-design/mobile-react'
import _ from 'lodash'
import styled from 'styled-components'

// import { useRequest } from '@/hooks/useRequest'

const Home: React.FC = () => {
  // 绑定dom元素
  const body = useRef<any>(null) // 视窗
  const landscape = useRef<any>(null) // 视频盒子
  const video1 = useRef<any>(null) // 视频
  const videoBox = useRef<any>(null) // canvas
  const animation = useRef<any>(null) // 动画
  const control = useRef<any>(null) // 控制栏
  const land = useRef<any>(null) // 横屏按钮
  const vertical = useRef<any>(null) // 竖屏按钮
  const rorate = useRef<any>(null) // 旋转1按钮
  const rorateFix = useRef<any>(null) // 旋转2按钮
  const rorateLand = useRef<any>(null) // 旋转3按钮
  const blackBox1 = useRef<any>(null) // 黑边1
  const blackBox2 = useRef<any>(null) // 黑边2

  const [sys, setSys] = useState<string>('') // 系统
  const direction = useRef<string>('vertical') // 横屏模式:"land"; 竖屏模式:"vertical", 旋转固定方向："rorateFix"， rorate："旋转带缩放";rorateLand: "横屏视频流旋转"
  const stateLed = useRef<string>('front') // 旋转模式下---横竖屏状态  "land":横屏； "vertical":竖屏
  const stateLedFB = useRef<string>('vertical') // "front": 左横、正竖； "back": 右横、倒竖

  const oldAlpha = useRef<number>(361)// 滤波
  const oldBeta = useRef<number>(361)
  const oldGamma = useRef<number>(361)

  const rotateAngle = useRef<number>(0)// 旋转角度
  const typeVer = useRef<number>(0) // 竖屏两个临界范围状态
  const typeLand = useRef<number>(0) // 横屏连两个临界范围状态

  const [statusPer, setStatusPer] = useState<boolean>(false) // 权限蒙层是否展示
  const [playStatus, setPlayStatus] = useState<boolean>(true) // 播放状态
  const [controlStatus, setControlStatus] = useState<boolean>(false) // 控制栏状态
  const isDraw = useRef<boolean>(false) // 是否将视频画到canvas中
  const videoStatus = useRef<boolean>(true) // 视频状态

  // 全局参数
  const verValue = 90 // 切竖屏临界参数
  const landValue = 20 // 切横屏临界参数
  const landValue2 = 90 - landValue // 互余角
  const range = 5 // 临界角度上下加减范围
  const frame = 12 // 动画再第6帧进行横竖切换  1秒25帧

  // const w = videoBox?.current?.width
  // const h = videoBox?.current?.height

  useEffect(() => {
    if (videoBox.current) {
      console.log('canvas放大')
      videoBox.current.width = videoBox.current.width * 10
      videoBox.current.height = videoBox.current.height * 10
    }
    getIosAnd()
    handleBodyClick()
  }, [])
  useEffect(() => {
    videoStatus.current = playStatus
  }, [playStatus])

  // 视频播放时候
  video1?.current?.addEventListener('play', function () {
    isDraw.current = true
    if (sys === 'Android') return
    switchToCanvas()
  })
  // 视频暂停时候
  video1?.current?.addEventListener('pasued', function () {
    isDraw.current = false
  })

  // 绘制视频
  function switchToCanvas () {
    if (!isDraw.current || sys === 'Android') {
      return
    }
    if (videoBox.current && video1.current) {
      const ctx = videoBox.current.getContext('2d')
      ctx?.drawImage(video1.current, 0, 0, videoBox.current.width, videoBox.current.height)
    }
    window.requestAnimationFrame(switchToCanvas)
  }
  const boxStyle = () => {
    const bodyWidth = body?.current?.offsetWidth
    const bodyHeight = body?.current?.offsetHeight
    // 补黑边
    if (blackBox2.current) {
      blackBox2.current.style.width = bodyWidth + 'px'
      blackBox2.current.style.height = (bodyHeight - (16 / 9) * bodyWidth) / 2 + 'px'
      blackBox2.current.style.bottom = 0
      blackBox2.current.style.left = 0
    }
    if (blackBox1.current) {
      blackBox1.current.style.width = bodyWidth + 'px'
      blackBox1.current.style.height = (bodyHeight - (16 / 9) * bodyWidth) / 2 + 'px'
      blackBox1.current.style.top = 0
      blackBox1.current.style.left = 0
    }
  }
  // 获取手机系统
  const getIosAnd = () => {
    const u = navigator.userAgent
    const isIOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/) // ios终端
    if (isIOS) {
      setSys('IOS')
      setStatusPer(true)
      // if (videoBox.current) {
      //   console.log(99999)

      //   videoBox.current.width = videoBox.current.width * 4
      //   videoBox.current.height = videoBox.current.height * 4

      //   console.log(videoBox.current.width, videoBox.current.height)
      // }
      if (video1.current) {
        video1.current.play()
        video1.current.muted = false
        video1.current.style.visibility = 'hidden'
      }
    } else {
      setTimeout(() => {
        if (video1.current) {
          video1.current.play()
          video1.current.muted = false
        }
      }, 1000)
      setSys('Android')

      boxStyle()
      handleControl() // 控制栏
      handleBoost() // 缩放
      handleRorateDeal() // 旋转

      handleMonitor()
    }
  }
  // 监听陀螺仪事件
  const handleMonitor = () => {
    if (window.addEventListener) {
      window.addEventListener(
        'deviceorientation',
        _.throttle(updateGravity, 0),
        false
      )
    } else {
      alert('您的手机不支持陀螺仪哦~')
    }
  }
  // 处理旋转数据
  const updateGravity = (event: any) => {
    boxStyle()
    if (videoStatus.current && video1.current) {
      video1.current.play()
    }
    // 滤波机制
    const angle = 0.1
    oldAlpha.current === 361 && (oldAlpha.current = event.alpha)
    oldBeta.current === 361 && (oldBeta.current = event.beta)
    oldGamma.current === 361 && (oldGamma.current = event.gamma)

    const subAlpha = event.alpha - oldAlpha.current
    const subBeta = event.beta - oldBeta.current
    const subGamma = event.gamma - oldGamma.current

    if (Math.abs(subAlpha) >= angle) {
      oldAlpha.current = event.alpha
    }
    if (Math.abs(subBeta) >= angle) {
      oldBeta.current = event.beta
    }
    if (Math.abs(subGamma) >= angle) {
      oldGamma.current = event.gamma
    }
    if (
      Math.abs(subAlpha) <= angle &&
      Math.abs(subBeta) <= angle &&
      Math.abs(subGamma) <= angle
    ) {
      return
    }

    const useBeta = oldBeta.current
    const useGamma = oldGamma.current

    // value2：旋转过程所取角度
    let beta2 = useBeta
    if (useBeta > 90) {
      beta2 = 180 - useBeta
    } else if (useBeta < -90) {
      beta2 = -(useBeta + 180)
    }
    let gamma2 = Math.abs(useBeta) > 90 ? -useGamma : useGamma
    const a = Math.abs(beta2 / 20)
    const temp = (a * a * a) / 10 + 1
    gamma2 = gamma2 / temp
    const value = Math.atan2(beta2, gamma2) / (Math.PI / 180)

    rotateAngle.current = value < 0 ? value + 360 : value

    // 水平放置始终保持放置前状态
    if (
      Number(useBeta) <= 20 &&
      Number(useBeta) >= -10 &&
      Number(useGamma) <= 15 &&
      Number(useGamma) >= -20
    ) {
      if (direction.current === 'rorateLand' || direction.current === 'rorate') {
        handleLevel()
      }
      return
    }
    handleCritical()
    event?.stopPropagation()
  }
  // 水平数据处理
  const handleLevel = () => {
    const bodyWidth = body?.current?.offsetWidth
    if (stateLed.current === 'vertical') {
      verticalPosition(90)
      control.current.style.width = bodyWidth + 'px'
      if (stateLedFB.current === 'front') {
        handleRorate(0)
        control.current.setAttribute('class', 'button-box')
      } else {
        handleRorate(180)
        control.current.setAttribute('class', 'button-box-top')
      }
    } else {
      landscapePosition(0)
      control.current.style.width = (16 / 9) * bodyWidth + 'px'
      if (stateLedFB.current === 'front') {
        handleRorate(90)
        control.current.setAttribute('class', 'button-box-landscape')
      } else {
        handleRorate(270)
        control.current.setAttribute('class', 'button-box-landscape-right')
      }
    }
  }
  // 临界点横竖屏切换
  const handleCritical = () => {
    if (rotateAngle.current >= verValue - range && rotateAngle.current <= verValue + range) {
      stateLed.current = 'vertical'
      stateLedFB.current = 'front'
    } else if (
      rotateAngle.current >= verValue + 180 - range &&
      rotateAngle.current <= verValue + 180 + range
    ) {
      stateLed.current = 'vertical'
      stateLedFB.current = 'back'
    } else if (
      (rotateAngle.current <= landValue + range && rotateAngle.current >= 0) ||
      (rotateAngle.current >= landValue + 180 + 2 * landValue2 - range &&
        rotateAngle.current <= 360)
    ) {
      stateLed.current = 'land'
      stateLedFB.current = 'back'
    } else if (
      rotateAngle.current > landValue + 2 * landValue2 - range &&
      rotateAngle.current < landValue + 180 + range
    ) {
      stateLed.current = 'land'
      stateLedFB.current = 'front'
    }

    if (direction.current === 'rorateFix') {
      handleAnimStatus()
    } else {
      handleControl() // 控制栏
      handleBoost() // 缩放
      handleRorateDeal() // 旋转
    }
  }

  // 横屏
  const landscapePosition = (value: number) => {
    const bodyWidth = body?.current?.offsetWidth
    const bodyHeight = body?.current?.offsetHeight
    if (bodyWidth && bodyHeight) {
      const num = Number(((value * Math.PI) / 180).toFixed(5)) // 角度
      const d =
        Math.abs(bodyHeight * Math.sin(num)) +
        Math.abs(bodyWidth * Math.cos(num)) // 横屏视频流最小高度

      // 横向视频流宽高
      const landVideoW = (16 / 9) * d
      const landVideoH = d

      // 根据原视频得出放大比例为 1920 / 1312.5
      const zoomPct = 1920 / 1312.5

      // 求出当前视频放大之后的宽高为
      const videoWidth = landVideoW * zoomPct
      const videoHeight = landVideoH * zoomPct

      const vh = videoHeight // 竖屏高
      const vw = vh * (9 / 16) // 竖屏宽
      const lw = videoWidth - vw // 横屏宽
      const lh = lw * (9 / 16) // 横屏高

      // 求出横屏xy中心点
      const lx = lw / 2
      const ly = lh / 2

      // 求出横屏中心点在整个视频中占的比例
      const lxPct = (lx / videoWidth) * 100
      const lyPct = (ly / videoHeight) * 100

      // 求出超出距离
      const lLeft = lx - bodyWidth / 2
      const lTop = ly - bodyHeight / 2

      // moveBox框样式赋值
      if (landscape.current) {
        landscape.current.style.width = bodyWidth + 'px'
        landscape.current.style.height = bodyHeight + 'px'
      }

      // 视频样式赋值
      if (sys === 'IOS') {
        if (videoBox.current) {
          videoBox.current.style.width = videoWidth + 'px'
          videoBox.current.style.height = videoHeight + 'px'
          videoBox.current.style['margin-left'] = -lLeft + 'px'
          videoBox.current.style['margin-top'] = -lTop + 'px'
          videoBox.current.style['transform-origin'] = `${lxPct}% ${lyPct}%`
        }
      } else {
        if (video1.current) {
          video1.current.style.width = videoWidth + 'px'
          video1.current.style.height = videoHeight + 'px'
          video1.current.style['margin-left'] = -lLeft + 'px'
          video1.current.style['margin-top'] = -lTop + 'px'
          video1.current.style['transform-origin'] = `${lxPct}% ${lyPct}%`
        }
      }
    }
  }
  // 竖屏
  const verticalPosition = (value: number) => {
    const bodyWidth = body?.current?.offsetWidth
    const bodyHeight = body?.current?.offsetHeight
    if (bodyWidth && bodyHeight) {
      const num = Number((((value - 90) * Math.PI) / 180).toFixed(5)) // 角度
      const d =
        Math.abs(bodyHeight * Math.sin(num)) +
        Math.abs(bodyWidth * Math.cos(num)) // 竖屏视频流最小宽度

      // 竖屏视频流宽高
      const verVideoW = d
      const verVideoH = (16 / 9) * d

      const zoomPct = 1920 / 607.5
      // 求出第一步放大之后的视频大小
      const videoWidth = verVideoW * zoomPct
      const videoHeight = verVideoH

      const vh = videoHeight // 竖屏高
      const vw = d // 竖屏宽
      const lw = videoWidth - vw // 横屏宽

      // 竖屏xy中心点
      const vx = vw / 2
      const vy = vh / 2

      // 计算竖屏中心点在整个视频中所占的比例
      // 横屏加竖屏宽度一半除以整体宽
      const vxPct = ((vx + lw) / videoWidth) * 100
      const vhPct = (vy / videoHeight) * 100

      // 计算偏移量
      const vLeft = lw + vw / 2 - bodyWidth / 2
      const vTop = vh / 2 - bodyHeight / 2

      // moveBox框样式赋值
      if (landscape.current) {
        landscape.current.style.width = bodyWidth + 'px'
        landscape.current.style.height = bodyHeight + 'px'
      }

      if (sys === 'IOS') {
        if (videoBox.current) {
          videoBox.current.style.width = videoWidth + 'px'
          videoBox.current.style.height = videoHeight + 'px'
          videoBox.current.style['margin-left'] = -vLeft + 'px'
          videoBox.current.style['margin-top'] = -vTop + 'px'
          videoBox.current.style['transform-origin'] = `${vxPct}% ${vhPct}%`
        }
      } else {
        if (video1.current) {
          video1.current.style.width = videoWidth + 'px'
          video1.current.style.height = videoHeight + 'px'
          video1.current.style['margin-left'] = -vLeft + 'px'
          video1.current.style['margin-top'] = -vTop + 'px'
          video1.current.style['transform-origin'] = `${vxPct}% ${vhPct}%`
        }
      }
    }
  }
  // 旋转
  const handleRorate = (value: number) => {
    const objAttr: any = {
      transform: `rotate(${value}deg)`
    }
    // 循环属性对象
    for (const i in objAttr) {
      let newi = i
      // 判断是否存在transform-origin这样格式的属性
      if (newi.indexOf('-') > 0) {
        const num = newi.indexOf('-')
        newi = newi.replace(
          newi.substr(num, 2),
          newi.substr(num + 1, 1).toUpperCase()
        )
      }
      // 考虑到css3的兼容性问题,所以这些属性都必须加前缀才行
      if (sys === 'IOS') {
        if (videoBox.current) {
          videoBox.current.style[newi] = objAttr[i]
          videoBox.current.style['-webkit-' + newi] = objAttr[i]
          videoBox.current.style['-moz-' + newi] = objAttr[i]
          videoBox.current.style['-o-' + newi] = objAttr[i]
          videoBox.current.style['-ms-' + newi] = objAttr[i]
        }
      } else {
        if (video1.current) {
          video1.current.style[newi] = objAttr[i]
          video1.current.style['-webkit-' + newi] = objAttr[i]
          video1.current.style['-moz-' + newi] = objAttr[i]
          video1.current.style['-o-' + newi] = objAttr[i]
          video1.current.style['-ms-' + newi] = objAttr[i]
        }
      }
    }
  }

  // 不同模式 控制栏处理
  const handleControl = () => {
    const bodyWidth = body?.current?.offsetWidth
    const bodyHeight = body?.current?.offsetHeight
    const marginNum = (bodyHeight - (16 / 9) * bodyWidth) / 2

    land.current && (land.current.style.color = direction.current === 'land' ? '#24adf3' : '#e7eaed')
    vertical.current && (vertical.current.style.color = direction.current === 'vertical' ? '#24adf3' : '#e7eaed')
    rorate.current && (rorate.current.style.color = direction.current === 'rorate' ? '#24adf3' : '#e7eaed')
    rorateFix.current && (rorateFix.current.style.color = direction.current === 'rorateFix' ? '#24adf3' : '#e7eaed')
    rorateLand.current && (rorateLand.current.style.color = direction.current === 'rorateLand' ? '#24adf3' : '#e7eaed')

    switch (direction.current) {
      case 'land':
        control?.current?.setAttribute('class', 'button-box-landscape')
        control.current && (control.current.style.width = (16 / 9) * bodyWidth + 'px')
        break
      case 'vertical':
        control?.current?.setAttribute('class', 'button-box')
        control.current && (control.current.style.width = bodyWidth + 'px')
        break
      default:
        if (stateLed.current === 'vertical' && control.current) {
          stateLedFB.current === 'front'
            ? control.current.setAttribute('class', 'button-box')
            : control.current.setAttribute('class', 'button-box-top')
          control.current.style.width = bodyWidth + 'px'
        }
        if (stateLed.current === 'land' && control.current) {
          stateLedFB.current === 'front'
            ? control.current.setAttribute('class', 'button-box-landscape')
            : control.current.setAttribute('class', 'button-box-landscape-right')
          control.current.style.width = (16 / 9) * bodyWidth + 'px'
        }
    }
    if (control.current) {
      control.current.style['margin-bottom'] = marginNum + 'px'
      control.current.style['margin-top'] = marginNum + 'px'
    }
  }
  // 不同模式 缩放处理
  const handleBoost = () => {
    switch (direction.current) {
      case 'land':
        landscapePosition(0) // 横屏
        break
      case 'vertical':
        verticalPosition(90) // 竖屏
        break
      case 'rorateFix':
        stateLed.current === 'land' && landscapePosition(0)
        stateLed.current === 'vertical' && verticalPosition(90)
        break
      case 'rorateLand':
        landscapePosition(rotateAngle.current)
        break
      default:
        stateLed.current === 'land' && landscapePosition(rotateAngle.current)
        stateLed.current === 'vertical' && verticalPosition(rotateAngle.current)
    }
  }
  // 不同模式 旋转处理
  const handleRorateDeal = () => {
    switch (direction.current) {
      case 'land':
        handleRorate(90)
        break
      case 'vertical':
        handleRorate(0)
        break
      case 'rorateFix':
        if (stateLed.current === 'land') {
          stateLedFB.current === 'front' ? handleRorate(90) : handleRorate(270)
        }
        if (stateLed.current === 'vertical') {
          stateLedFB.current === 'front' ? handleRorate(0) : handleRorate(180)
        }
        break
      default:
        handleRorate(rotateAngle.current - 90)
    }
  }

  // 处理动画 限制频率
  const handleAnimation = () => {
    if (animation.current) {
      animation.current.setAttribute('src', '')
      animation.current.setAttribute(
        'src',
        'https://fe-assets-1301947356.cos.ap-beijing.myqcloud.com/test-ios/transition-animation/3_shu25.gif'
      )
      animation.current.style.visibility = 'visible'

      setTimeout(function () {
        handleControl() // 控制栏
        handleBoost() // 缩放
        handleRorateDeal() // 旋转
        setTimeout(function () {
          animation.current.style.visibility = 'hidden'
        }, (18 / 25) * 1000)
      }, (12 / 25) * 1000)
    }
  }
  const functionDe = _.debounce(handleAnimation, (frame / 25) * 2 * 1000, {
    leading: true
  })
  // 动画：范围值内只触发一次
  const handleAnimStatus = () => {
    if (stateLed.current === 'vertical') {
      if (typeVer.current !== 1) {
        typeVer.current = 1
        typeLand.current = 0
        functionDe()
      }
    }
    if (stateLed.current === 'land') {
      if (typeLand.current !== 1) {
        typeVer.current = 0
        typeLand.current = 1
        functionDe()
      }
    }
  }

  //= ====================================点击事件=========================================
  // ios获取权限点击事件
  const handlePermissionClick = (event: any) => {
    if (video1.current) {
      video1.current.play()
    }
    if ((window.DeviceOrientationEvent as any).requestPermission) {
      console.log('获取ios权限333');
      (window.DeviceOrientationEvent as any).requestPermission()
        .then((state: string) => {
          setStatusPer(false)
          if (state === 'granted') {
            // 允许
            console.log('获取ios权限')

            handleControl() // 控制栏
            handleBoost() // 缩放
            handleRorateDeal() // 旋转
            handleMonitor()
          } else if (state === 'denied') {
            // 拒绝
            alert('您已拒绝授权，请退出重新进入授权')
          } else if (state === 'prompt') {
            alert('遇到未知错误，请退出重新进入')
          }
        })
        .catch((code: any) => {
          setStatusPer(false)
        })
    } else {
      setStatusPer(false)
      alert('当前浏览器不支持，请使用Safari浏览器')
    }
    event?.stopPropagation()
  }
  // 屏幕点击事件
  let timeOut: any
  const handleBodyClick = () => {
    console.log('屏幕点击事件')

    const visible = !controlStatus
    control.current && (control.current.style.display = visible ? 'block' : 'none')
    setControlStatus(Boolean(visible))
    if (visible) {
      timeOut = setTimeout(function () {
        control.current && (control.current.style.display = 'none')
        setControlStatus(false)
      }, 5000)
    } else {
      clearTimeout(timeOut)
    }
  }
  // 暂停播放按钮点击事件
  const handlePlayClick = (value: number, event: any) => {
    console.log('播放状态', value)

    setPlayStatus(Boolean(value))
    if (video1.current) {
      value ? video1.current.play() : video1.current.pause()
    }
    event.stopPropagation()
  }
  // 不同模式按钮点击事件
  const handleModelClick = (value: number, event: any) => {
    switch (value) {
      case 1:
        direction.current = 'land'
        stateLed.current = 'land'
        stateLedFB.current = 'front'
        vertical.current && (vertical.current.removeEventListener('click', handleModelClick))
        break
      case 2:
        direction.current = 'vertical'
        stateLed.current = 'vertical'
        stateLedFB.current = 'front'
        land.current && (land.current.removeEventListener('click', handleModelClick))
        break
      default:
        direction.current = value === 4 ? 'rorateFix' : value === 5 ? 'rorateLand' : 'rorate'
        stateLed.current = 'vertical'
        stateLedFB.current = 'front'
        land.current && (land.current.removeEventListener('click', handleModelClick))
        vertical.current && (vertical.current.removeEventListener('click', handleModelClick))
      // if (value === 4 || value === 5) {
      //   land.current && (land.current.style.color = "#e7eaed")
      //   vertical.current && (vertical.current.style.color = "#e7eaed")
      //   rorate.current && (rorate.current.style.color = "#e7eaed")
      //   rorateFix.current && (rorateFix.current.style.color = value === 4 ? "#24adf3" : "#e7eaed")
      //   rorateLand.current && (rorateLand.current.style.color = value === 5 ? "#24adf3" : "#e7eaed")
      // }
    }
    handleControl() // 控制栏
    handleBoost() // 缩放
    handleRorateDeal() // 旋转
    event?.stopPropagation()
  }
  return (
    <Layout>
      <div className='App' ref={body} onClick={handleBodyClick}>
        {/* 黑边限制可视化区域 */}
        <div className="blackBox" ref={blackBox1}></div>
        <div className="blackBox" ref={blackBox2}></div>
        {/* 动画 */}
        <img ref={animation} className="animation" alt=""
          src="https://fe-assets-1301947356.cos.ap-beijing.myqcloud.com/test-ios/transition-animation/3_shu25.gif"></img>

        {/* ios获取权限蒙层 */}
        {statusPer && (<div className="permissionLoading">
          <div className="getPermission" onClick={handlePermissionClick}>点击获取权限</div>
        </div>)}

        {/* 视频 */}
        <div ref={landscape} className="landscape">
          {sys === 'IOS' && (<canvas ref={videoBox} className="videoBox"></canvas>)}
          <video
            ref={video1}
            muted
            loop
            autoPlay
            poster="文件地址"
            playsInline
            className="video2"
            src="https://fe-assets-1301947356.cos.ap-beijing.myqcloud.com/test-ios/transition-animation/1108_20M.mp4"
          ></video>

        </div>

        {/* 控制栏  */}
        <div id='control' ref={control}>
          <div className="button-model">
            <div className="button-play">
              {!playStatus && (
                <img
                  className="playIcon"
                  src="https://ig-internal--files-1301947356.cos.ap-beijing.myqcloud.com/icons/11515429d65ac392d8b930087f451e3.png"
                  onClick={(event) => handlePlayClick(1, event)}
                  alt=""
                />
              )}
              {playStatus && (
                <img
                  className="stopIcon"
                  src="https://ig-internal--files-1301947356.cos.ap-beijing.myqcloud.com/icons/cb47c56c95e7b940b9ac0fec7d967ff.png"
                  onClick={(event) => handlePlayClick(0, event)}
                  alt=""
                />
              )}
            </div>
            <div className="button-text">
              <div ref={land} className="button" onClick={(evnet) => handleModelClick(1, evnet)}>横屏</div>
              <div ref={vertical} className="button " onClick={(evnet) => handleModelClick(2, evnet)}>竖屏</div>
              <div ref={rorate} className="button" onClick={(evnet) => handleModelClick(3, evnet)}>旋转1</div>
              <div ref={rorateFix} className="button" onClick={(evnet) => handleModelClick(4, evnet)}>
                旋转2
              </div>
              <div ref={rorateLand} className="button" onClick={(evnet) => handleModelClick(5, evnet)}>
                旋转3
              </div>
            </div>
          </div>
        </div>

      </div>
    </Layout>
  )
}

export default Home

const Layout = styled.div`
  position: relative;
  width: 100%;
  height: 100vh;
  /* background: #000
    url('https://fe-internal-files-1301947356.cos.ap-beijing.myqcloud.com/public/image/background.svg')
    no-repeat 50%; */
  .App {
  width: 100vw;
  height: 100vh;
  font-family: Monospace;
  background-color: #000;
  margin: 0px;
  overflow: hidden;
}
.animation {
  width: 100vw;
  height: 100vh;
  position: absolute;
  visibility: hidden;
  object-fit: cover;
  z-index: 12;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
}
.landscape {
  width: 100vw;
  height: 100vh;
  overflow: hidden;
}
.videoBox {
  width: 100%;
  height: 100%;
  transform: translateZ(0);
  position: absolute;
}
.video2 {
  visibility: visible;
  width: 100%;
  height: 100%;
  object-fit: cover;
  position: absolute;
  overflow: hidden;
}
.blackBox {
  width: 0;
  height: 0;
  position: absolute;
  background-color: #000;
  z-index: 10;
}
.permissionLoading {
  position: absolute;
  z-index: 12;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background-color: #ffffffb0;
}
.getPermission {
  width: 100%;
  height: 80px;
  position: absolute;
  font-size: 30px;
  font-weight: 600;
  line-height: 80px;
  text-align: center;
  margin: 0 auto;
  top: 50%;
  transform: translateY(-50%);
  color: red;
}
#control {
  display: block;
  width: 100vw;
  height: 50px;
  margin-bottom: 0;
  position: absolute;
  z-index: 10;
  background: rgba(0, 0, 0, 0.5);
}
.button-box {
  width: 100%;
  bottom: 0;
  left: 0;
}
.button-box-top {
  width: 100%;
  top: 0;
  left: 0;
  transform: rotate(180deg);
}
.button-box-landscape {
  width: 100%;
  top: -25px;
  left: 25px;
  transform-origin: left;
  transform: rotate(90deg);
}
.button-box-landscape-right {
  width: 100%;
  top: -25px;
  right: 25px;
  transform-origin: right;
  transform: rotate(270deg);
}
.button-model {
  display: flex;
  width: 100%;
  height: 100%;
  position: absolute;
  justify-content: space-between;
  align-items: center;
  /* margin: 0 40px; */
}
.button-text {
  display: flex;
}
.button-play {
  width: 30px;
  height: 30px;
  display: flex;
}
.button {
  width: 50px;
  height: 100%;
  display: flex;
  justify-content: center;
  align-items: center;
  line-height: 50px;
  padding: 0 5px;
  color: #e7eaed;
  font-size: 16px;
}

`
